#include <iostream.h>
#include <string.h>
#include "polka.H"
#include "heapsort.H"

extern MyAnimator heapsort;

void BuildHeap();
void Heapify(int);

int Heap[129];
int heapsize;

main(int argc, char *argv[])
{
   int i, temp, length;
   char label[50];



   heapsort.RegisterAlgoEvt("Init","d");
   heapsort.RegisterAlgoEvt("AddNode","dd");
   heapsort.RegisterAlgoEvt("Elevate","d");
   heapsort.RegisterAlgoEvt("Heapify","d");
   heapsort.RegisterAlgoEvt("BuildHeap","d");
   heapsort.RegisterAlgoEvt("CompareLeft","d");
   heapsort.RegisterAlgoEvt("CompareBoth","d");
   heapsort.RegisterAlgoEvt("Exchange","dd");
   heapsort.RegisterAlgoEvt("Sift","dd");
   heapsort.RegisterAlgoEvt("Finished","d");
   heapsort.RegisterAlgoEvt("Message","s");
   heapsort.RegisterAlgoEvt("WAIT",NULL);

   printf("Input number of elts to be heap-sorted\n");
   scanf("%d", &heapsize);

   length = heapsize;
   heapsort.SendAlgoEvt("Init",heapsize);

   heapsort.SendAlgoEvt("Message","Reading in Array");

   printf("Enter the elements\n");
   for (i=0; i<heapsize; ++i)
      { scanf("%d", &Heap[i]);
      }

   for (i=0; i<heapsize; ++i) {
      heapsort.SendAlgoEvt("AddNode",i,Heap[i]);
      }

   heapsort.SendAlgoEvt("Message","Build Heap");
   BuildHeap();
   heapsort.SendAlgoEvt("Message", "  ");
   for (i=heapsize-1; i>0; i--) {
      temp = Heap[i];
      Heap[i] = Heap[0];
      Heap[0] = temp;
      sprintf(label, "Elevate %d", i+1);
      heapsort.SendAlgoEvt("Message", label);
      heapsort.SendAlgoEvt("Exchange",0,i);
      heapsort.SendAlgoEvt("Finished",i);
      heapsize--;
      heapsort.SendAlgoEvt("Heapify",0);
      Heapify(0);
      }

   printf("Sorted array is\n");
   for (i=0; i<length; ++i)
      printf("%d ", Heap[i]);
   printf("\n");

   while (1)
      heapsort.SendAlgoEvt("WAIT");
}



void
BuildHeap()
{
   int i;

   for (i=heapsize/2; i>=0; i--) {
      heapsort.SendAlgoEvt("BuildHeap",i);
      heapsort.SendAlgoEvt("Heapify", i);
      Heapify(i);
      }
}




void
Heapify(int pos)
{
   int largest, left, right, i, temp;

   left = 2*pos + 1;
   right = 2*pos + 2;

   if (right < heapsize)
      heapsort.SendAlgoEvt("CompareBoth",pos);
   else if (left < heapsize)
      heapsort.SendAlgoEvt("CompareLeft",pos);
  
   if ((left<heapsize) && (Heap[left] > Heap[pos]))
         largest = left;
      else
         largest = pos;

   if ((right<heapsize) && (Heap[right] > Heap[largest]))
         largest = right;

   if (largest != pos) {
      temp = Heap[pos];
      Heap[pos] = Heap[largest];
      Heap[largest] = temp;
      heapsort.SendAlgoEvt("Sift",pos,largest);
      Heapify(largest);
      }
}





