#include <iostream.h>
//#include <fstream.h>
#include <math.h>
#include "polka.H"
#include "heapsort.H"


MyAnimator  heapsort;



int
MyAnimator::Controller()
{
//   cout << "In controller aen=" << AlgoEvtName << "\n";

   if (!strcmp(AlgoEvtName,"Init"))  {
      sv.Init(AnimInts[0]);
      nv.Init(AnimInts[0]);
      }
   else if (!strcmp(AlgoEvtName,"AddNode")) {
      sv.AddNode(AnimInts[0],AnimInts[1]);
      nv.Input(AnimInts[0],AnimInts[1]);
      }
   else if (!strcmp(AlgoEvtName,"Elevate")) 
      sv.Elevate(AnimInts[0]);
   else if (!strcmp(AlgoEvtName,"Heapify")) 
      sv.HeapPtr(AnimInts[0]);
   else if (!strcmp(AlgoEvtName,"BuildHeap")) 
      sv.BuildPtr(AnimInts[0]);
   else if (!strcmp(AlgoEvtName,"CompareLeft")) 
      sv.CompareLeft(AnimInts[0]);
   else if (!strcmp(AlgoEvtName,"CompareBoth")) 
      sv.CompareBoth(AnimInts[0]);
   else if (!strcmp(AlgoEvtName,"Exchange"))   {
      sv.Exchange(AnimInts[0],AnimInts[1]);
      nv.Exchange(AnimInts[0],AnimInts[1]);
      }
   else if (!strcmp(AlgoEvtName,"Sift")) {   
      sv.Sift(AnimInts[0],AnimInts[1]);
      nv.Exchange(AnimInts[0],AnimInts[1]);
      }
   else if (!strcmp(AlgoEvtName,"Finished"))  {
      sv.Done(AnimInts[0]);
      nv.Done(AnimInts[0]);
      }
   else if (!strcmp(AlgoEvtName,"Message"))  
      sv.Message(AnimStrings[0]);
   else
      sv.CheckInput();
   return(1);
}






int
SortView::Init(int n)
{
   int edges,count,i,j;
   double x,y,dx,dy;

   printf("***Init %d\n", n);
   Create("Heap Sort (Tree view)");
   SetBgColor("black");
   edges = (int) (log( (double)n )/log(2.0));

   count = 0;
   dy = 0.6 / double(edges);
   y = 0.9;
   for (i=0; i<=edges; i++) {
       x = dx = 1.0 / double(two_to_the(i) + 1);
       for (j=1; j<=two_to_the(i); j++) {
          tree[count++] = new Loc(x,y);
          x += dx;
       }
       if (count >= n) break;
       y -= dy;
   }

   x = 0.1;
   for (i=0; i< n; i++) {
       spots[i] = new Loc(x, 0.1);
       x += 0.8/double(n-1);
   }


   heapifier = new Text(this, 1,0.03,0.97, "white", 
                           "Variable", "H", 1);
   heapifier->Originate(1);

//   builder = new Text(this, 1,0.01,0.95, "white", 
//                           "Variable", "B", 1);
   builder = new Circle(this, 1, 0.1,0.95, radius+0.02, "white", 0.0);
   builder->Originate(1);

   return(5);
}


int
SortView::AddNode(int num, int val)
{
   char 	  str[10];
   double	  x,y,sx,sy,nx,ny;
   Loc           *north,*south;

printf("***AddNode %d %d\n", num, val);
   sprintf(str,"%d",val);
   x = tree[num]->XCoord();
   y = tree[num]->YCoord();
   node[num] = new Circle(this, 1,x,y, radius, "yellow", 1.0);
   node[num]->Originate(time);
   label[num] = new Text(this, 1,x,y, "black", 
                           "lucidasanstypewriter-bold-18", str, 1);
   label[num]->Originate(time);

   if (num != 0) {   // not the root
      north = node[num]->Where(PART_N);
      nx = north->XCoord();
      ny = north->YCoord();
      south = node[(num-1)/2]->Where(PART_S);  // from parent node
      sx = south->XCoord();
      sy = south->YCoord();
      edge[num] = new Line(this, 1,nx,ny, sx-nx,sy-ny, "white",0.5,1.0,0);
      edge[num]->Originate(time);
      }
   time = Animate(time,5);
   return(5);
}


int
SortView::Elevate(int num)
{
   int len;

printf("***Elevate %d\n", num);
   Action a1("MOVE", tree[0], spots[num], SPEED);
   len = node[0]->Program(time, &a1);
   len = label[0]->Program(time, &a1);
   if (num != 0)
      { Action a2("MOVE", tree[num], tree[0], SPEED);
        edge[num]->Delete(time+len);
        label[num]->Program(time+len, &a2);
        len += node[num]->Program(time+len, &a2);
      }
   node[0] = node[num];
   label[0] = label[num];
   time = Animate(time,len);
   return(len);
}


int
SortView::HeapPtr(int num)
{
   int len;
   Loc *nw,*now;
   double nx,ny;

printf("***HeapPtr %d\n", num);
   now = heapifier->Where(PART_E);
   nw = node[num]->Where(PART_W);
//   nx = nw->XCoord();
//   ny = nw->YCoord();

   Action a1("MOVE", now, nw, 1.0);
   len = heapifier->Program(time, &a1);
   time = Animate(time,len);

   delete(nw);
   delete(now);

   return(len);
}


int
SortView::BuildPtr(int num)
{
   int len;
   Loc *nw,*now;
   double nx,ny;

printf("***BuildPtr %d\n", num);
   now = builder->Where(PART_C);
   nw = node[num]->Where(PART_C);
//   nx = nw->XCoord();
//   ny = nw->YCoord();

   Action a1("MOVE", now, nw, 1.0);
   len = builder->Program(time, &a1);
   time = Animate(time,len);

   delete(nw);
   delete(now);

   return(len);
}


int
SortView::Done(int num)
{
   int len;

   edge[num]->Delete(time);
   time = Animate(time, 1);

   delete(edge[num]);
   return(1);
}


int
SortView::CompareLeft(int num)
{
   int len;

printf("***CompareLeft %d\n", num);
   Action red("COLOR", "red");
   Action yellow("COLOR", "yellow");
   Action *a3 = red.Iterate(3);
   Action *b3 = yellow.Iterate(3);
   Action *cc = a3->Concatenate(b3);
   Action *flash = cc->Iterate(4);

   len = node[num]->Program(time, flash);
   len = node[num*2+1]->Program(time, flash);   // left child
   delete(a3);
   delete(b3);
   delete(cc);
   delete(flash);
   time = Animate(time,len);
   return(len);
}




int
SortView::CompareBoth(int num)
{
   int len;

printf("***CompareBoth %d\n", num);
   Action red("COLOR", "red");
   Action yellow("COLOR", "yellow");
   Action *a3 = red.Iterate(3);
   Action *b3 = yellow.Iterate(3);
   Action *cc = a3->Concatenate(b3);
   Action *flash = cc->Iterate(4);

   len = node[num]->Program(time, flash);
   len = node[num*2+1]->Program(time, flash);   // left child
   len = node[num*2+2]->Program(time, flash);   // right child
   delete(a3);
   delete(b3);
   delete(cc);
   delete(flash);
   time = Animate(time,len);
   return(len);
}


int
SortView::Sift(int i, int j)
{
   int len1, len2;
   Circle *tempc;
   Text *tempt;
   Loc *now, *nw;

printf("***Sift %d %d\n", i, j);
   Action a1("MOVE", tree[i], tree[j], SPEED);
   Action a2("MOVE", tree[j], tree[i], SPEED);
   len1 = node[i]->Program(time, &a1);
   len1 = label[i]->Program(time, &a1);
   len1 = node[j]->Program(time, &a2);
   len1 = label[j]->Program(time, &a2);
   now = heapifier->Where(PART_E);
   nw = node[j]->Where(PART_W);

   Action a3("MOVE", now, nw, SPEED);
   len2 = heapifier->Program(time, &a3);

   time = Animate(time,(len1>len2) ? len1 : len2);

   tempc = node[i];
   node[i] = node[j];
   node[j] = tempc;
   tempt = label[i];
   label[i] = label[j];
   label[j] = tempt;

   delete(nw);
   delete(now);

   return(len2);
}




int
SortView::Exchange(int i, int j)
{
   int len;
   Circle *tempc;
   Text *tempt;

printf("***Exchange %d %d\n", i, j);
   Action a1("MOVE", tree[i], tree[j], SPEED);
   Action a2("MOVE", tree[j], tree[i], SPEED);
   len = node[i]->Program(time, &a1);
   len = label[i]->Program(time, &a1);
   len = node[j]->Program(time, &a2);
   len = label[j]->Program(time, &a2);
   tempc = node[i];
   node[i] = node[j];
   node[j] = tempc;
   tempt = label[i];
   label[i] = label[j];
   label[j] = tempt;
   time = Animate(time,len);
   return(len);
}




int
SortView::Message(char *str)
{
   static Text *msg = NULL;

   if (msg)
      msg->Delete(time);
   msg = new Text(this, 1, 0.5, 0.97, "white", "10x20",
            str, 1);
   msg->Originate(time);
   return(0);
}








int
Names::Init(int n)
{
   Create("Heapsort (Array View)", CoordStretch, 700, 80);
   SetBgColor("black");
   numvals = n;
   barrier = new Rectangle(this, 1, 0.98,0.1, 0.003,0.8, "white", 1.0);
   barrier->Originate(1);
   return(0);
}



/* save the values in the array */

int
Names::Input(int index,int val)
{
   int len;
   static double x = 0.05;
   double spacing;
   char str[5];

   spacing = 0.9 / (double) (numvals-1);

   values[index] = val;
   sprintf(str,"%d",values[index]);
   labels[index] = new Text(this,1, x,0.5,"white","10x20",str,1);
   labels[index]->Originate(0);
   x += spacing;

   Action a("DELAY",1);
   len = labels[index]->Program(time,&a);
   time = Animate(time, len);
   return(len);
}




/* make the two rectangles exchange positions on the screen in one */
/* simultaneous movement                                           */

int
Names::Exchange(int i, int j)
{
   Text *tempt;
   LocPtr loc1,loc2;
   int len;

   loc1 = labels[i]->Where(PART_C);
   loc2 = labels[j]->Where(PART_C);
   Action a("MOVE",loc1,loc2,CLOCKWISE);
   Action *b = a.Rotate(180);
   len = labels[i]->Program(time,&a);
   labels[j]->Program(time,b);
   time = Animate(time, len);

   tempt = labels[i];
   labels[i] = labels[j];
   labels[j] = tempt;

   delete b;
   return(len);
}


int
Names::Done(int pos)
{
   int len;
   Loc *loc1, *loc2;   

   loc1 = barrier->Where(PART_E);
   loc2 = labels[pos]->Where(PART_W);
   Action a("MOVE",loc1,loc2,4);
   len = barrier->Program(time, &a);
   time = Animate(time, len);
   delete(loc1);
   delete(loc2);

   return(len);
}