#include <iostream.h>
#include <string.h>
#include <errno.h>
#include "polka.H"
#include "insort.H"


MyAnimator sorter;


int
MyAnimator::Controller()
{
   static int time=0;

//   cout << "In controller aen=" << AlgoEvtName << "\n";

   if (!strcmp(AlgoEvtName,"Init")) {
      r.Init();
      d.Init();
   }
   else if (!strcmp(AlgoEvtName,"Input")) {
      r.Input(AnimInts[0],AnimInts[1]);
      d.Input(AnimInts[0],AnimInts[1]);
   }
   else if (!strcmp(AlgoEvtName,"Ready")) {
      r.Ready(AnimInts[0]);
      d.Draw(AnimInts[0]);
   }
   else if (!strcmp(AlgoEvtName,"Mover")) { 
      r.Highlight(AnimInts[0], 1);
      d.Highlight(AnimInts[0], 1);
   }
   else if (!strcmp(AlgoEvtName,"Exchange")) { 
      r.Exchange(AnimInts[0],AnimInts[1]);
      d.Exchange(AnimInts[0],AnimInts[1]);
   }
   else if (!strcmp(AlgoEvtName,"InPlace")) { 
      r.Highlight(AnimInts[0], 0);
      d.Highlight(AnimInts[0], 0);
   }
   else
      r.CheckInput();

   return(1);
}




int
Rects::Init()
{
   Create("Quicksort (Blocks View)");
   return (0);
}



/* save the values in the array */

int
Rects::Input(int index,int val)
{
   val++;   // get values from 0->n-1, so add 1
   values[index] = val;
   if (val > max) max=val;
   if (val < min) min=val;
   return(1);
}




/* Draw the array as a row of rectangles with the heights corresponding */
/* to the value of each array element.					*/

int
Rects::Ready(int n)
{
   int i;
   RectangleGroup objs;

   strcpy(objs.color,"black");
   objs.spacetype = SpacingNone;
   objs.horiz = 1;
   objs.align = AlignBottom;
   objs.fill = 1.0;
   objs.useints = 1;
   objs.intvals = values;
   objs.intmin = min;
   objs.intmax = max;
   objs.Make(this,blocks,n,0.1,0.1,0.9,0.9);

   for (i=0; i<n; ++i)
      blocks[i]->Originate(0);

   time = Animate(time,10);
   return(10);
}


/* Make the two rectangles exchange positions on the screen in one */
/* simultaneous movement					   */

int
Rects::Exchange(int i, int j)
{
   Rectangle *tempr;
   LocPtr loc1,loc2;
   int len;

   loc1 = blocks[i]->Where(PART_SW);
   loc2 = blocks[j]->Where(PART_SW);
   Action a("MOVE",loc1,loc2,1);
   Action *b = a.Reverse();
   len = blocks[i]->Program(time,&a);
   blocks[j]->Program(time,b);
   time = Animate(time,len);

   tempr = blocks[i];
   blocks[i] = blocks[j];
   blocks[j] = tempr;

   delete b;
   return(len);
}




// Highlight the element being sifted into the earlier elements

int
Rects::Highlight(int pos, int on)
{
   int len;
   Action *a;

   if (on)
      a = new Action("COLOR", "green");
   else
      a = new Action("COLOR", "black");
   len = blocks[pos]->Program(time, a);
   time = Animate(time, len);
   delete a;
   return(len);
}






const double DISTANCE = 0.1;





void
Dots::Init()
{
   Create("Dots View");
}



/* save the values in the array */

void
Dots::Input(int index, int val)
{
   values[index] = val;
}





void
Dots::Draw(int n)
{
   double spacing,lx;
   int i,len;

   spacing = 1.0 / (double) n;
   lx = 0.0;

   for (i=0; i<n; ++i)
      { elts[i] = new Rectangle(this,1,lx,(double)values[i]*spacing,
                     spacing,spacing,"black",1.0);
        lx += spacing;
        elts[i]->Originate(0);
      }

   Action a("DELAY", 1);
   len = elts[0]->Program(time,&a);
   time = Animate(time,len);
}



void
Dots::Exchange(int p1, int p2)
{
   int len;
   double x1,y1,x2,y2;
   Loc *loc1f,*loc2f;
   Rectangle *temp;

   loc1f = elts[p1]->Where(PART_C);
   x1 = loc1f->XCoord();
   y1 = loc1f->YCoord();
   loc2f = elts[p2]->Where(PART_C);
   x2 = loc2f->XCoord();
   y2 = loc2f->YCoord();
   Loc loc1t(x2, y1);
   Loc loc2t(x1, y2);

   Action a1("MOVE", loc1f, &loc1t, DISTANCE);
   Action a2("MOVE", loc2f, &loc2t, DISTANCE);
   
   len = elts[p1]->Program(time,&a1);
   len = elts[p2]->Program(time,&a2);

   time = Animate(time, len);

   temp = elts[p1];
   elts[p1] = elts[p2];
   elts[p2] = temp;
   delete(loc1f);
   delete(loc2f);
}




// Highlight the element being sifted into the earlier elements

void
Dots::Highlight(int pos, int on)
{
   int len;
   Action *a;

   if (on)
      a = new Action("COLOR", "green");
   else
      a = new Action("COLOR", "black");
   len = elts[pos]->Program(time, a);
   time = Animate(time, len);
   delete a;
}




