//#include <stream.h>
#include <iostream.h>
//#include <strings.h>
#include <string.h>
#include <errno.h>
//#include <osfcn.h>
#include "polka.H"
#include "qsort.H"


MyAnimator qsortA;


int
MyAnimator::Controller()
{
   static int time=0;

//   cout << "In controller aen=" << AlgoEvtName << "\n";

   if (!strcmp(AlgoEvtName,"Init")) {
      r.Init();
   }
   else if (!strcmp(AlgoEvtName,"Input")) {
      r.Input(AnimInts[0],AnimInts[1]);
   }
   else if (!strcmp(AlgoEvtName,"Ready")) {
      r.Ready(AnimInts[0]);
   }
   else if (!strcmp(AlgoEvtName,"Exchange")) { 
      r.Exchange(AnimInts[0],AnimInts[1]);
   }
   else
      r.CheckInput();

   return(1);
}


int
Rects::Init()
{
   Create("Quicksort (Blocks View)");
   return (0);
}



/* save the values in the array */

int
Rects::Input(int index,int val)
{
   values[index] = val;
   if (val > max) max=val;
   if (val < min) min=val;
   return(1);
}




/* Draw the array as a row of rectangles with the heights corresponding */
/* to the value of each array element.					*/

int
Rects::Ready(int n)
{
   int i;
   RectangleGroup objs;

   strcpy(objs.color,"black");
   objs.spacetype = SpacingNone;
   objs.horiz = 1;
   objs.align = AlignBottom;
   objs.fill = 1.0;
   objs.useints = 1;
   objs.intvals = values;
   objs.intmin = min;
   objs.intmax = max;
   objs.Make(this,blocks,n,0.1,0.1,0.9,0.9);

   for (i=0; i<n; ++i)
      blocks[i]->Originate(0);

   time = Animate(time,10);
   return(10);
}


/* Make the two rectangles exchange positions on the screen in one */
/* simultaneous movement					   */

int
Rects::Exchange(int i, int j)
{
   Rectangle *tempr;
   LocPtr loc1,loc2;
   int len;

   loc1 = blocks[i]->Where(PART_SW);
   loc2 = blocks[j]->Where(PART_SW);
   Action a("MOVE",loc1,loc2,7);
   Action *b = a.Reverse();
   len = blocks[i]->Program(time,&a);
   blocks[j]->Program(time,b);
   time = Animate(time,len);

   tempr = blocks[i];
   blocks[i] = blocks[j];
   blocks[j] = tempr;

   delete b;
   return(len);
}


