#include <iostream.h>
#include <string.h>
#include "polka.H"
#include "quicksort.H"


MyAnimator qs_anim;


const double DISTANCE = 0.1;

int
MyAnimator::Controller()
{
   printf("In controller aen=%s\n", AlgoEvtName);

   if (!strcmp(AlgoEvtName,"Init")) {
      q.Init();
      r.Init();
   }
   else if (!strcmp(AlgoEvtName,"Input")) {
      q.Input(AnimInts[0],AnimInts[1]);
      r.Input(AnimInts[0],AnimInts[1]);
   }
   else if (!strcmp(AlgoEvtName,"Display")) {
      r.Ready(AnimInts[0]);
      q.Draw(AnimInts[0]);
   }
   else if (!strcmp(AlgoEvtName,"Exchange")) { 
      q.Exchange(AnimInts[0],AnimInts[1]);
      r.Exchange(AnimInts[0],AnimInts[1]);
   }
   else 
      q.CheckInput();
   return(1);
}





void
QSView::Init()
{
   Create("Quicksort");
}



/* save the values in the array */

void
QSView::Input(int index, int val)
{
   values[index] = val;
}





void
QSView::Draw(int n)
{
   double spacing,lx;
   int i,len;

   spacing = 1.0 / (double) n;
   lx = 0.0;

   for (i=0; i<n; ++i)
      { elts[i] = new Rectangle(this,1,lx,(double)values[i]*spacing,
                     spacing,spacing,"black",1.0);
        lx += spacing;
        elts[i]->Originate(0);
      }

   Action a("DELAY", 10);
   len = elts[0]->Program(time,&a);
   time = Animate(time,len);
}



void
QSView::Exchange(int p1, int p2)
{
   int len;
   double x1,y1,x2,y2;
   Loc *loc1f,*loc2f;
   Rectangle *temp;

   loc1f = elts[p1]->Where(PART_C);
   x1 = loc1f->XCoord();
   y1 = loc1f->YCoord();
   loc2f = elts[p2]->Where(PART_C);
   x2 = loc2f->XCoord();
   y2 = loc2f->YCoord();
   Loc loc1t(x2, y1);
   Loc loc2t(x1, y2);

   Action a1("MOVE", loc1f, &loc1t, DISTANCE);
   Action a2("MOVE", loc2f, &loc2t, DISTANCE);
   
   Action red("COLOR", "red");
   Action black("COLOR", "black");

   elts[p1]->Program(time,&red);
   elts[p2]->Program(time,&red);
   len = elts[p1]->Program(time,&a1);
   len = elts[p2]->Program(time,&a2);

   time = Animate(time, len);

   len = elts[p1]->Program(time,&black);
   len = elts[p2]->Program(time,&black);

   time = Animate(time, len);

   temp = elts[p1];
   elts[p1] = elts[p2];
   elts[p2] = temp;
   delete(loc1f);
   delete(loc2f);
}





int
Rects::Init()
{
   Create("Quicksort (Blocks View)");
   return (0);
}



/* save the values in the array */

int
Rects::Input(int index,int val)
{
printf("Input %d %d\n",index,val);
   values[index] = val;
   if (val > max) max=val;
   if (val < min) min=val;
   return(1);
}




/* Draw the array as a row of rectangles with the heights corresponding */
/* to the value of each array element.					*/

int
Rects::Ready(int n)
{
   int i;
   RectangleGroup objs;

   strcpy(objs.color,"black");
   objs.spacetype = SpacingNone;
   objs.horiz = 1;
   objs.align = AlignBottom;
   objs.fill = 1.0;
   objs.useints = 1;
   objs.intvals = values;
   objs.intmin = min;
   objs.intmax = max;
   objs.Make(this,blocks,n,0.1,0.1,0.9,0.9);

   for (i=0; i<n; ++i)
      blocks[i]->Originate(0);

   time = Animate(time,10);
   return(10);
}


/* Make the two rectangles exchange positions on the screen in one */
/* simultaneous movement					   */

int
Rects::Exchange(int i, int j)
{
   Rectangle *tempr;
   LocPtr loc1,loc2;
   int len;

printf("Exchange %d %d\n",i,j);
   loc1 = blocks[i]->Where(PART_SW);
   loc2 = blocks[j]->Where(PART_SW);
   Action a("MOVE",loc1,loc2,7);
   Action *b = a.Reverse();
   len = blocks[i]->Program(time,&a);
   blocks[j]->Program(time,b);
   time = Animate(time,len);

   tempr = blocks[i];
   blocks[i] = blocks[j];
   blocks[j] = tempr;

   delete b;
   return(len);
}


