#define CACHE_X 8
#define CACHE_Y 4
#define DB_X 15
#define DB_Y 5
#define MAX_TIME 48
#define TIME_WINDOW 12
#define NOT_VALID_YET -1
#define EXPIRED -2

class SuperCache : public View {
  public:
   int Init();
   int Input(int,int,int);
   int Ready(int);
   int Clock(int);
   int Colors(int,int,int);
   int Enable();
   int Query(int,int,int);

  private:
   Rectangle *clockr;
   Rectangle *sc_recs[8][4];
   Rectangle *db_recs[15][5];
   Rectangle *db_hilite[4];
   Rectangle *sc_hilite;
   Rectangle *change_rec;
   Text *change_label;
   Text *sc_labels[8][4];
   Text *clock_label;
   Text *q_labels[10]; 
};


class MyAnimator : public Animator {
  public:
   int Controller();
   MyAnimator() 
    { RegisterView(&sc);
    };
  private:
   SuperCache sc;
};




