#include <iostream.h>
#include <string.h>
//#include <stream.h>
//#include <strings.h>
#include <errno.h>
//#include <osfcn.h>
#include <polka.H>
#include "tdq.H"


MyAnimator tdq;

Rectangle *border[CACHE_X][CACHE_Y], *clock_border;
Set *mover[10];
Set *change_movr;
Text *db_title, *sc_title, *q_title; int flag = 0;


int
MyAnimator::Controller()
{
   static int time=0;
   int len;


   if (!strcmp(AlgoEvtName,"Init")) { sc.Init();
   }
   if (!strcmp(AlgoEvtName,"Input")) {
      len = sc.Input(AnimInts[0],AnimInts[1],AnimInts[2]);
   }
   else if (!strcmp(AlgoEvtName,"Ready")) {
      len = sc.Ready(AnimInts[0]);
   }
   else if (!strcmp(AlgoEvtName,"Clock")) {
	len = sc.Clock(AnimInts[0]);
   }
   else if (!strcmp(AlgoEvtName,"Colors"))  {
      len = sc.Colors(AnimInts[0],AnimInts[1],AnimInts[2]);
   }
   else if (!strcmp(AlgoEvtName,"Query"))  { 
      len = sc.Query(AnimInts[0],AnimInts[1],AnimInts[2]);
   }
   else {
      sc.CheckInput();
      }
   return(1);
}


int
SuperCache::Init()
{
   Create("Queries on Time Sensitive Data Using a Super Cached Data Base",
	   CoordStretch,800,800);
   SetBgColor("tan");
   return(0);
}


/* Load the random time stamps generated by the algorithm into the local copy
   of the super cache. */

int
SuperCache::Input(int i, int j, int k)
{
   char str[3];
   int len;

   sc_recs[i][j]->StoreData((void *)k);
   sprintf(str,"%i",k);

   Action d("ALTER",str);
   len = sc_labels[i][j]->Program(time,&d);

   time = Animate(time,len);

   return(len);
}


/* Set up the graphical objects on the screen and then delay before beginning
   the animation.  The database is represented by the grid of grey rectangles
   near the top of the window, the supercache by the rectangles in the middle
   of the window, the clock by the rectangle in the upper right corner, and the
   querie rectangles are created on the fly and lined up along the bottom of
   the window as they are generated. */

int
SuperCache::Ready(int sc_colm)
{
   int len,i,j;
   double x,y,width,height;
   Loc *center;

   width = 0.6/DB_X;
   height = 0.3/DB_Y;

   db_hilite[0] = new Rectangle(this,1,0.096+width*3,0.694+height*0,width,
				height,"tan",1.0);
   db_hilite[0]->Originate(0);
   db_hilite[1] = new Rectangle(this,1,0.096+width*9,0.694+height*2,width,
				height,"tan",1.0);
   db_hilite[1]->Originate(0);
   db_hilite[2] = new Rectangle(this,1,0.096+width*11,0.694+height*4,width,
				height,"tan",1.0);
   db_hilite[2]->Originate(0);
   db_hilite[3] = new Rectangle(this,1,0.096+width*14,0.694+height*2,width,
				height,"tan",1.0);
   db_hilite[3]->Originate(0);


   for (i=0; i<DB_X; i++) {
	for (j=0; j<DB_Y; j++) {
	    x = 0.1 + width*i;
	    y = 0.7 + height*j;
	    db_recs[i][j] = new Rectangle(this,1,x,y,0.8*width,0.8*height,
					 "LightGrey",1.0);
	    db_recs[i][j]->Originate(0);
	}
   }


   width = 0.5/CACHE_X;
   height = 0.3/CACHE_Y;

   sc_hilite = new Rectangle(this,1,0.297+width*sc_colm,0.347,width,4*height,
			     "red",0.0);
   sc_hilite->Originate(0);

   for (i=0; i<CACHE_X; i++) {
	for (j=0; j<CACHE_Y; j++) {
	    x = 0.3 + width*i;
            y = 0.35 + height*j;
            border[i][j] = new Rectangle(this,1,x,y,0.9*width,0.9*height,
                                         "white",1.0);
            border[i][j]->Originate(0);

            x = 0.3 + width * (i+0.04);
            y = 0.35 + height * (j+0.04);
            sc_recs[i][j] = new Rectangle(this,1,x,y,0.8*width,0.8*height,
                                         "white",1.0);
	    sc_recs[i][j]->Originate(0);

            center = sc_recs[i][j]->Where(PART_C);
            x = center->XCoord();
            y = center->YCoord();
            sc_labels[i][j] = new Text(this,1,x,y,"white",NULL,"",1);
            sc_labels[i][j]->Originate(0);
	}
   }

   change_rec = new Rectangle(this,1,0.9,0.7,0.032,0.048,"tan",1.0);
   change_rec->Originate(0);
   change_label = new Text(this,1,0.915,0.72,"white",NULL,"",1);
   change_label->Originate(0);

   clock_border = new Rectangle(this,1,0.9,0.9,0.1,0.1,"#000000",1.0);
   clock_border->Originate(0);
   clockr = new Rectangle(this,1,0.91,0.91,0.09,0.09,"#000000",1.0);
   clockr->Originate(0);
   center = clockr->Where(PART_C);
   x = center->XCoord();
   y = center->YCoord();
   clock_label = new Text(this,1,x,y,"white",NULL,"",1);
   clock_label->Originate(0);

   sc_title = new Text(this,1,0.55,0.34,"black",NULL,"Super Cache",1);
   sc_title->Originate(0);

   db_title = new Text(this,1,0.4,0.69,"black",NULL,"Data Base",1);
   db_title->Originate(0);

   Action a("DELAY",10);
   len = sc_recs[0][0]->Program(time,&a);

   time = Animate(time,len);

   return(len);
}



/* Update the clock value by one.  Also, at time = 25 make the change to the
   database symbolized by the blue rectangle that comes from the right hand 
   side.  This is hardwired at this point to just do one change at a specific
   time.  This could easily be generalized to handle multiple changes at any
   given time by adding a function to handle this and following the method
   used here. */

int
SuperCache::Clock(int i)
{
   char str[3];
   int len;
   Loc *loc1, *loc2;
   AnimObject *objs[2];

   sprintf(str,"%d",i);

   if (i == 25) {
	objs[0] = change_rec;
	objs[1] = change_label;
	change_movr = new Set(this,2,objs);

   	Action a("COLOR","blue");
	len = change_rec->Program(time,&a);
	Action b("ALTER","41");
	len = change_label->Program(time,&b);

	time = Animate(time,len);

        loc1 = change_rec->Where(PART_SW);
        loc2 = db_recs[3][0]->Where(PART_SW);
        Action c("MOVE",loc1,loc2,STRAIGHT);	
        len = change_movr->Program(time,&c);

	time = Animate(time,len);

	flag = 1;
   }

   Action e("ALTER",str);
   len = clock_label->Program(time,&e);

   time = Animate(time,len); 

   return(len);
}


/* Update the color of rectangle i,j in the supercache with the new color 
   indicated by k. */

int
SuperCache::Colors(int i, int j, int k)
{
   int r=0,g=0,b=0,temp;
   char col[7],str[3];
   Rectangle *new_rec;
   double width, height, fill;

   temp = (int)sc_recs[i][j]->RetrieveData();
   if (k > temp) {
	temp = -2;
   } else if ((temp - k) >= TIME_WINDOW) {
	temp = -1;
   } else {
	temp = temp - k;
   }

   g = 14*temp + 101;

   if (temp == -1) {
	r = 255;
	g = 255;
	b = 255;
   } else if (temp == -2) {
	r = 0;
	g = 0;
	b = 0;
   }

   sprintf(col,"#%02x%02x%02x",r,g,b);

   sc_recs[i][j]->GetValues(NULL,NULL,NULL,NULL,&width,&height,NULL,NULL);
   new_rec = new Rectangle(this,1,0.0,0.0,width,height,col,1.0);

   sc_recs[i][j]->Change(time,new_rec,1);

   time = Animate(time,1);

   return(1);
}


/* This handles the query event.  "colm" indicates which column in the super
   cache to query, "num" indicates how many queries have happened, and "tm" 
   holds the time at which the query was generated.  Right now the queries are 
   generated at random times generated in the main algorithm, this could be 
   easily changed. */

int
SuperCache::Query(int colm, int num, int tm)
{
    int len,len2,i,k,r,g,b;
    double x,y,width,height,fill;
    Loc *center, *loc1, *loc2, *loc3;
    AnimObject *obj[8];
    char col[7], str[7];
    Action *flash;

    len = 0;

    Action c1("COLOR","red");
    Action c2("COLOR","tan");
    flash = c1.Concatenate(&c2);
    flash = flash->Iterate(4);

    for (i=0; i<4; i++) {
	len += db_hilite[i]->Program(time+len,flash);
    }

    time = Animate(time,len);

    if (flag == 1) {
	loc2 = change_rec->Where(PART_SW);
 	loc3 = sc_recs[colm][2]->Where(PART_SW);
	Action m("MOVE",loc2,loc3,STRAIGHT);
	len = change_movr->Program(time,&m);

	time = Animate(time,len);

	change_movr->Delete(time);
	change_rec->Delete(time);
	change_label->Delete(time);

	Action t("ALTER","41");
	len = sc_labels[colm][2]->Program(time,&t);

	time = Animate(time,len);

   	sc_recs[colm][2]->StoreData((void *)41);
	tdq.SendAlgoEvt("Colors",colm,2,tm);

	flag = 0;
    }


    for (i=0; i<CACHE_Y; i++) {

	sc_recs[colm][i]->GetValues(NULL,NULL,&x,&y,&width,&height,col,&fill);

	obj[i] = new Rectangle(this,1,x,y,width,height,col,fill);
    	obj[i]->Originate(0);
	sprintf(str,"%d",(int)(sc_recs[colm][i]->RetrieveData()));
	center = obj[i]->Where(PART_C);
        x = center->XCoord();
        y = center->YCoord();
        obj[i+4] = new Text(this,1,x,y,"white",NULL,str,1);
        obj[i+4]->Originate(0);
    }

    sprintf(str,"");
    sprintf(str,"t = %d",tm);

    mover[num] = new Set(this,8,obj);
    loc1 = mover[num]->Where(PART_SW);
    loc2 = new Loc(0.95,0.0);
    loc3 = new Loc(0.02+num*0.1,0.0);
    Action a("MOVE",loc1,loc2,CLOCKWISE);	
    len = mover[num]->Program(time,&a);
    Action d("MOVE",loc2,loc3,STRAIGHT);
    len2 = mover[num]->Program(time+len,&d);

    x = 0.033+0.1*num;
    y = 0.3;
    q_labels[num] = new Text(this,1,x,y,"white",NULL,str,1);
    q_labels[num]->Originate(time + len + len2);

    time = Animate(time,len+len2);

    return(len);
}
