#ifndef __POLKA_GC_H
#define __POLKA_GC_H

/***************************************************************/
/*							                                   */
/*	       		polka_gc.H			                           */
/*							                                   */
/***************************************************************/
/*       Copyright 1993, 1997 Georgia Institute of Technology 
                     -- John T. Stasko, Roman S. Khramets      */

/**************************************************************/
/*****************	LOCAL data types     ******************/
/**************************************************************/

#include <windows.h>
#include "System.h"

typedef enum {LineSolid, LineOnOffDash} LineStyle;
typedef COLORREF Pixel;
typedef COLORREF XColor;

typedef LOGFONT XFontStruct;

typedef struct {
   char *name;
   XFontStruct *xfs;
   HFONT hFont;
   } GC_FONT;

typedef struct {
   DWORD  width;		/* 0, 2, 4 		      */
   DWORD  line_style;	/* LineSolid or LineOnOffDash */
   char   dash_list[2];
} GC_LINE;


/**************************************************************/
/*****************	GLOBAL variables     ******************/
/**************************************************************/

/**************************************************************/
/*****************	LOCAL variables      ******************/
/**************************************************************/

#define DEFAULTFONT      ""
#define DEFAULTFONTNUM   0
#define MAXFONTS         20
#define MAXFILLS	     41
#define NUMDEFAULTFILLS  41
#define MAXLINESTYLES     9
#define UNINITIALIZED	 -1

Pixel             GetXColor(COLORINDEX);

#endif